> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://mailchimp.com/developer/marketing/api/lists/batch-subscribe-or-unsubscribe/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://mailchimp.com/_mcp/server. # Batch subscribe or unsubscribe POST https://api.mailchimp.com/3.0/lists/{list_id} Content-Type: application/json Batch subscribe or unsubscribe list members. Reference: https://mailchimp.com/developer/marketing/api/lists/batch-subscribe-or-unsubscribe ## Authentication - `Authorization` header (bearer token, required) — Authorization using a Mailchimp API key (a.k.a. Bearer token) - `Authorization` header (bearer token, required) — Authorization using OAuth ## Request ### Path parameters - `list_id` (string, required) — The unique ID for the list. ### Query parameters - `skip_merge_validation` (boolean, optional) — If skip_merge_validation is true, member data will be accepted without merge field values, even if the merge field is usually required. This defaults to false. - `skip_duplicate_check` (boolean, optional) — If skip_duplicate_check is true, we will ignore duplicates sent in the request when using the batch sub/unsub on the lists endpoint. The status of the first appearance in the request will be saved. This defaults to false. ### Body (application/json) This endpoint expects an object. - `members` (list of 30ListsListIdPostRequestBodyContentApplicationJsonSchemaMembersItems, required) — An array of objects, each representing an email address and the subscription status for a specific list. Up to 500 members may be added or updated with each API call. - `sync_tags` (boolean, optional, nullable) — Whether this batch operation will replace all existing tags with tags in request. - `update_existing` (boolean, optional, nullable) — Whether this batch operation will change existing members' subscription status. ## Response ### 200 - `_links` (list of 30ListsListIdPostResponsesContentApplicationJsonSchemaLinksItems, optional) — A list of link types and descriptions for the API schema documents. - `error_count` (integer, optional) — The total number of items matching the query, irrespective of pagination. - `errors` (list of 30ListsListIdPostResponsesContentApplicationJsonSchemaErrorsItems, optional) — An array of objects, each representing an email address that could not be added to the list or updated and an error message providing more details. - `new_members` (list of ListsPost, optional) — An array of objects, each representing a new member that was added to the list. - `total_created` (integer, optional) — The total number of items matching the query, irrespective of pagination. - `total_updated` (integer, optional) — The total number of items matching the query, irrespective of pagination. - `updated_members` (list of ListsPost, optional) — An array of objects, each representing an existing list member whose subscription status was updated. ## Types ### 30ListsListIdPostRequestBodyContentApplicationJsonSchemaMembersItems Individuals who are currently or have been previously subscribed to this list, including members who have bounced or unsubscribed. ### 30ListsListIdPostResponsesContentApplicationJsonSchemaLinksItems This object represents a link from the resource where it is found to another resource or action that may be performed. - `href` (string, optional) — This property contains a fully-qualified URL that can be called to retrieve the linked resource or perform the linked action. - `method` (enum, optional) — The HTTP method that should be used when accessing the URL defined in 'href'. - Allowed values: `GET`, `POST`, `PUT`, `PATCH`, `DELETE`, `OPTIONS`, `HEAD` - `rel` (string, optional) — As with an HTML 'rel' attribute, this describes the type of link. - `schema` (string, optional) — For HTTP methods that can receive bodies (POST and PUT), this is a URL representing the schema that the body should conform to. - `targetSchema` (string, optional) — For GETs, this is a URL representing the schema that the response should conform to. ### 30ListsListIdPostResponsesContentApplicationJsonSchemaErrorsItems - `email_address` (string, optional) — The email address that could not be added or updated. - `error` (string, optional) — The error message indicating why the email address could not be added or updated. - `error_code` (enum, optional) — A unique code that identifies this specifc error. - Allowed values: `ERROR_CONTACT_EXISTS`, `ERROR_GENERIC` - `field` (string, optional) — If the error is field-related, information about which field is at issue. - `field_message` (string, optional) — Message indicating how to resolve a field-related error. ### ListsPost Individuals who are currently or have been previously subscribed to this list, including members who have bounced or unsubscribed. - `_links` (list of ListsPostLinksItems, optional) — A list of link types and descriptions for the API schema documents. - `contact_id` (string, optional) — A unique ID for the contact record. - `email_address` (string, optional) — Email address for a subscriber. - `email_client` (string, optional) — The list member's email client. - `email_type` (string, optional) — Type of email this member asked to get ('html' or 'text'). - `id` (string, optional) — The MD5 hash of the lowercase version of the list member's email address. - `interests` (map from string to boolean, optional) — The key of this object's properties is the ID of the interest in question. - `ip_opt` (string, optional) — The IP address the subscriber used to confirm their opt-in status. - `ip_signup` (string, optional) — IP address the subscriber signed up from. - `language` (string, optional) — If set/detected, the [subscriber's language](https://mailchimp.com/help/view-and-edit-contact-languages/). - `last_changed` (datetime, optional) — The date and time the member's info was last changed in ISO 8601 format. - `last_note` (ListsPostLastNote, optional) — The most recent Note added about this member. - `list_id` (string, optional) — The list id. - `location` (ListsPostLocation, optional) — Subscriber location information. - `member_rating` (integer, optional) — Star rating for this member, between 1 and 5. - `merge_fields` (map from string to any, optional) — An individual merge var and value for a member. - `stats` (ListsPostStats, optional) — Open and click rates for this subscriber. - `status` (enum, optional) — Subscriber's current status. - Allowed values: `subscribed`, `unsubscribed`, `cleaned`, `pending`, `transactional` - `tags` (list of ListsPostTagsItems, optional) — The tags applied to this member. - `tags_count` (integer, optional) — The number of tags applied to this member. - `timestamp_opt` (datetime, optional) — The date and time the subscriber confirmed their opt-in status in ISO 8601 format. - `timestamp_signup` (datetime, optional) — The date and time the subscriber signed up for the list in ISO 8601 format. - `unique_email_id` (string, optional) — An identifier for the address across all of Mailchimp. - `vip` (boolean, optional) — [VIP status](https://mailchimp.com/help/designate-and-send-to-vip-contacts/) for subscriber. ### ListsPostLinksItems This object represents a link from the resource where it is found to another resource or action that may be performed. - `href` (string, optional) — This property contains a fully-qualified URL that can be called to retrieve the linked resource or perform the linked action. - `method` (enum, optional) — The HTTP method that should be used when accessing the URL defined in 'href'. - Allowed values: `GET`, `POST`, `PUT`, `PATCH`, `DELETE`, `OPTIONS`, `HEAD` - `rel` (string, optional) — As with an HTML 'rel' attribute, this describes the type of link. - `schema` (string, optional) — For HTTP methods that can receive bodies (POST and PUT), this is a URL representing the schema that the body should conform to. - `targetSchema` (string, optional) — For GETs, this is a URL representing the schema that the response should conform to. ### ListsPostLastNote The most recent Note added about this member. - `created_at` (datetime, optional) — The date and time the note was created in ISO 8601 format. - `created_by` (string, optional) — The author of the note. - `note` (string, optional) — The content of the note. - `note_id` (integer, optional) — The note id. ### ListsPostLocation Subscriber location information. - `country_code` (string, optional) — The unique code for the location country. - `dstoff` (integer, optional) — The offset for timezones where daylight saving time is observed. - `gmtoff` (integer, optional) — The time difference in hours from GMT. - `latitude` (double, optional) — The location latitude. - `longitude` (double, optional) — The location longitude. - `timezone` (string, optional) — The timezone for the location. ### ListsPostStats Open and click rates for this subscriber. - `avg_click_rate` (double, optional) — A subscriber's average clickthrough rate. - `avg_open_rate` (double, optional) — A subscriber's average open rate. ### ListsPostTagsItems - `id` (integer, optional) — The tag id. - `name` (string, optional) — The name of the tag ## Examples **Request** ```json { "members": [ null ] } ``` **Response** ```json { "_links": [ { "href": "string", "method": "GET", "rel": "string", "schema": "string", "targetSchema": "string" } ], "error_count": 42, "errors": [ { "email_address": "string", "error": "string", "error_code": "ERROR_CONTACT_EXISTS", "field": "string", "field_message": "string" } ], "new_members": [ { "_links": [ { "href": "string", "method": "GET", "rel": "string", "schema": "string", "targetSchema": "string" } ], "contact_id": "string", "email_address": "string", "email_client": "string", "email_type": "string", "id": "string", "interests": {}, "ip_opt": "string", "ip_signup": "string", "language": "string", "last_changed": "2024-01-15T09:30:00Z", "last_note": { "created_at": "2024-01-15T09:30:00Z", "created_by": "string", "note": "string", "note_id": 1 }, "list_id": "string", "location": { "country_code": "string", "dstoff": 1, "gmtoff": 1, "latitude": 1.1, "longitude": 1.1, "timezone": "string" }, "member_rating": 1, "merge_fields": {}, "stats": { "avg_click_rate": 1.1, "avg_open_rate": 1.1 }, "status": "subscribed", "tags": [ { "id": 1, "name": "string" } ], "tags_count": 1, "timestamp_opt": "2024-01-15T09:30:00Z", "timestamp_signup": "2024-01-15T09:30:00Z", "unique_email_id": "string", "vip": true } ], "total_created": 42, "total_updated": 42, "updated_members": [ { "_links": [ { "href": "string", "method": "GET", "rel": "string", "schema": "string", "targetSchema": "string" } ], "contact_id": "string", "email_address": "string", "email_client": "string", "email_type": "string", "id": "string", "interests": {}, "ip_opt": "string", "ip_signup": "string", "language": "string", "last_changed": "2024-01-15T09:30:00Z", "last_note": { "created_at": "2024-01-15T09:30:00Z", "created_by": "string", "note": "string", "note_id": 1 }, "list_id": "string", "location": { "country_code": "string", "dstoff": 1, "gmtoff": 1, "latitude": 1.1, "longitude": 1.1, "timezone": "string" }, "member_rating": 1, "merge_fields": {}, "stats": { "avg_click_rate": 1.1, "avg_open_rate": 1.1 }, "status": "subscribed", "tags": [ { "id": 1, "name": "string" } ], "tags_count": 1, "timestamp_opt": "2024-01-15T09:30:00Z", "timestamp_signup": "2024-01-15T09:30:00Z", "unique_email_id": "string", "vip": true } ] } ``` **SDK Code** ```python import requests url = "https://api.mailchimp.com/3.0/lists/list_id" payload = { "members": [None] } headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://api.mailchimp.com/3.0/lists/list_id'; const options = { method: 'POST', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{"members":[null]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.mailchimp.com/3.0/lists/list_id" payload := strings.NewReader("{\n \"members\": [\n null\n ]\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.mailchimp.com/3.0/lists/list_id") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"members\": [\n null\n ]\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.mailchimp.com/3.0/lists/list_id") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"members\": [\n null\n ]\n}") .asString(); ``` ```php request('POST', 'https://api.mailchimp.com/3.0/lists/list_id', [ 'body' => '{ "members": [ null ] }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.mailchimp.com/3.0/lists/list_id"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"members\": [\n null\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = ["members": []] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.mailchimp.com/3.0/lists/list_id")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` > Find all the Mailchimp API documentation and tools developers need to send marketing and transactional emails.